#!/usr/bin/env node
// Generated by CoffeeScript 2.4.1
//!/usr/bin/env coffee
var AppName, D, E, GetOpt, P, PackageName, PersistUniqueRandom, command, ctx, e, optUsages, rng;

GetOpt = require('@kssfilo/getopt');

AppName = "unique-random";

PackageName = "persist-unique-random";

P = console.log;

E = (e) => {
  var ref;
  switch (false) {
    case (ref = typeof e) !== 'string' && ref !== 'value':
      return console.error(e);
    case !ctx.isDebugMode:
      return console.error(e.toString());
    default:
      /*
      if e[0]?.message
      	console.error e[0].message
      else
      */
      return console.error(e);
  }
};

D = (str) => {
  if (ctx.isDebugMode) {
    return E(`${AppName}:` + str);
  }
};

ctx = {
  command: 'print',
  isDebugMode: false
};

optUsages = {
  h: "show this help",
  d: "debug mode",
  r: "reset specified random array. ",
  R: "reset all random arrays.",
  i: ["id", "random array id. random arrays are saved per id+min+max pair. default('ID')"],
  x: ["max", "max value. e.g. 10 -> [0..9]. default:16"],
  n: ["min", "min value. default:0"],
  s: "re-shuffle when random array loops. default:loops same array",
  S: ["number", "force override seed number. e.g. 12345. default:random number or saved seed."],
  D: ["dir", "directory to save random array seeds. default:$HOME/.persist-unique-random"],
  f: ["file", "file name to save random array seeds. default:persist-unique-random"],
  N: "don't save/load random arrays.(generates non-unique random number)"
};

try {
  GetOpt.setopt('h?drRi:x:n:sS:D:f:N');
} catch (error) {
  e = error;
  switch (e.type) {
    case 'unknown':
      E(`Unknown option:${e.opt}`);
      break;
    case 'required':
      E(`Required parameter for option:${e.opt}`);
  }
  process.exit(1);
}

try {
  GetOpt.getopt(function(o, p) {
    switch (o) {
      case 'h':
      case '?':
        return ctx.command = 'usage';
      case 'd':
        return ctx.isDebugMode = true;
      case 'r':
        return ctx.command = 'reset';
      case 'R':
        return ctx.command = 'resetAll';
      case 'i':
        return ctx.id = p[0];
      case 'n':
        return ctx.min = Number(p[0]);
      case 'x':
        return ctx.max = Number(p[0]);
      case 'D':
        return ctx.fileDir = p[0];
      case 'f':
        return ctx.fileName = p[0];
      case 'S':
        return ctx.forceSeed = Number(p[0]);
      case 'N':
        return ctx.persist = false;
      case 's':
        return ctx.reshuffle = true;
    }
  });
  if (ctx.command === 'usage') {
    P(`## Command line\n\n	${AppName} [options]\n	\n	Unique Random Array Generator with Persist(saving to file) Feature + Command Line Tool\n	\n	Copyright (C) 2019-2019 @kssfilo(https://kanasys.com/gtech/)\n\n## Options\n\n${GetOpt.getHelp(optUsages)}		\n\n## Examples\n`);
    process.exit(0);
  }
  D(`==starting ${AppName}`);
  D("sanity checking..");
  D("..OK");
  D("-------");
  D("-options");
  D(`${JSON.stringify(ctx, null, 2)}`);
  if (ctx.isDebugMode) {
    if (ctx.restCommand != null) {
      E(`command:${ctx.restCommand}`);
    }
    if (ctx.restCommand != null) {
      E(`method:${ctx.command}`);
    }
    if (ctx.restParam != null) {
      E(`params:${JSON.stringify(ctx.restParam)}`);
    }
  }
  PersistUniqueRandom = require('./persist-unique-random');
  command = ctx.command;
  delete ctx.command;
  rng = new PersistUniqueRandom(ctx); //sinse of compatibility
  switch (command) {
    case 'print':
      P(`${rng.next()}`);
      break;
    case 'reset':
      rng.reset();
      E('OK');
      break;
    case 'resetAll':
      rng.resetAll();
      E('OK');
  }
} catch (error) {
  e = error;
  E(console.error(e.toString()));
  process.exit(1);
}
