// Generated by CoffeeScript 2.4.1
var Fs, Path, PersistUniqueRandom, SeedRandom;

SeedRandom = require('seedrandom');

Fs = require('fs');

Path = require('path');

PersistUniqueRandom = (function() {
  var _Class, _ModuleName;

  _Class = class {
    _D(str) {
      if (this.isDebugMode) {
        return console.error(`${_ModuleName}:${str}`);
      }
    }

    _ID() {
      return `${this.id}${this.min}-${this.max}`;
    }

    _P() {
      var ref;
      return (ref = this.p[this._ID()]) != null ? ref : null;
    }

    _generateArray() {
      var da, max, min, random, ref, sa;
      ({min, max} = this);
      random = SeedRandom(this._P().seed);
      da = [];
      sa = (function() {
        var results = [];
        for (var i = min, ref = max - 1; min <= ref ? i <= ref : i >= ref; min <= ref ? i++ : i--){ results.push(i); }
        return results;
      }).apply(this);
      while (sa.length) {
        da.push(sa.splice(Math.floor(random() * sa.length), 1)[0]);
      }
      return this.array = da;
    }

    constructor(opt) {
      var ref, ref1, ref2, ref3, ref4, ref5;
      this.p = {};
      this.fileDir = (ref = opt.fileDir) != null ? ref : Path.join(process.env["HOME"], `.${_ModuleName}`);
      this.fileName = (ref1 = opt != null ? opt.fileName : void 0) != null ? ref1 : 'persist-unique-random.json';
      this.filePath = Path.join(this.fileDir, this.fileName);
      this.isDebugMode = opt != null ? opt.isDebugMode : void 0;
      this.max = (ref2 = opt != null ? opt.max : void 0) != null ? ref2 : 16;
      this.min = (ref3 = opt != null ? opt.min : void 0) != null ? ref3 : 0;
      this.id = (ref4 = opt != null ? opt.id : void 0) != null ? ref4 : "ID";
      this.persist = (ref5 = opt != null ? opt.persist : void 0) != null ? ref5 : true;
      this.reshuffle = opt != null ? opt.reshuffle : void 0;
      if (!(this.load() && this._P())) {
        this.reset();
      }
      if ((opt != null ? opt.forceSeed : void 0) != null) {
        this._P().seed = opt.forceSeed;
      }
      this._generateArray();
    }

    reset() {
      this._D(`resetting random array id:${this._ID()}`);
      this.p[this._ID()] = {};
      this._P().seed = Math.floor(Math.random() * 0x10000000);
      this._P().index = 0;
      return this.save();
    }

    resetAll() {
      this._D("clearing all random arrays");
      this.p = {};
      this.reset();
      return this.save();
    }

    save() {
      if (!this.persist) {
        return;
      }
      this._D(`saving to ${this.filePath}...`);
      if (!Fs.existsSync(this.fileDir)) {
        this._D(`${this.fileDir} doesn't exist. try mkdir`);
        Fs.mkdirSync(this.fileDir);
      }
      this._D(`data:${JSON.stringify(this.p)}`);
      return Fs.writeFileSync(this.filePath, JSON.stringify(this.p));
    }

    load() {
      var e;
      if (!this.persist) {
        return false;
      }
      try {
        this._D(`loading from ${this.filePath}..`);
        this.p = JSON.parse(Fs.readFileSync(this.filePath));
        this._D(`data:${JSON.stringify(this.p)}`);
        return true;
      } catch (error) {
        e = error;
        this._D("file doesnt exists.skip.");
        return false;
      }
    }

    next() {
      var r;
      this._D(this.array);
      this._D(this._P().index);
      r = this.array[this._P().index++];
      if (this._P().index >= this.array.length) {
        if (this.reshuffle) {
          this._D("option.reshuffle is specified. re-generate array..");
          this.reset();
          this._generateArray();
        }
        this._P().index = 0;
      }
      this.save();
      return r;
    }

  };

  _ModuleName = 'persist-unique-random';

  return _Class;

}).call(this);

module.exports = PersistUniqueRandom;
